/*
   SndPlaySystemSoundHack
   $Revision: 0.1 $
   Tatsuya Aoyagi (aoyagi@cs.uec.ac.jp)
   $Id: play.c,v 0.1 1997/08/06 11:35:44 aoyagi Exp aoyagi $
*/
#pragma pack(2)

#include <Pilot.h>
#include "syssnd.h"

void playMelody(ULong creator,Int melodyID) {
  DmOpenRef dbref;
  VoidHand melhand;
  Melody* melody;
  int i;
  SndCommandType sndCmd;
  Long delay;

  dbref = DmOpenDatabaseByTypeCreator(MelodyDBType,creator,dmModeReadOnly);
  if (dbref == 0) { return; }
  melhand = DmGet1Resource(MelodyResourceType,melodyID);
  if (melhand == 0) { DmCloseDatabase(dbref); return; }
  melody = (Melody*)MemHandleLock(melhand);
  sndCmd.cmd = sndCmdFreqDurationAmp;
  for (i = 0; i < melody->numOfNotes; i++) {
    sndCmd.param1 = melody->notes[i].frequency;
    sndCmd.param2 = melody->notes[i].duration;
    sndCmd.param3 = melody->notes[i].amplitude;
    if (melody->notes[i].frequency == 0 || melody->notes[i].amplitude == 0) {
      delay = melody->notes[i].duration / 10;
      if (melody->notes[i].duration % 10 >= 5) { delay++; }
      SysTaskDelay(delay);
    } else {
      SndDoCmd(0,&sndCmd,0);
    }
  }
  MemHandleUnlock(melhand);
  DmReleaseResource(melhand);
  DmCloseDatabase(dbref);
}
