/*
   SndPlaySystemSoundHack
   $Revision: 0.1 $
   Tatsuya Aoyagi (aoyagi@cs.uec.ac.jp)
   $Id: prefdb.c,v 0.1 1997/08/06 11:35:44 aoyagi Exp aoyagi $
*/
#pragma pack(2)

#include <Pilot.h>
#include "prefdb.h"

DmOpenRef openPrefDatabase() {
  DmOpenRef dbref;
  dbref = DmOpenDatabaseByTypeCreator(PrefDBType,HackCreatorID,dmModeReadWrite);
  if (dbref == 0) {
    if (DmCreateDatabase(0,PrefDBName,HackCreatorID,PrefDBType,false) != 0) { return 0; }
    dbref = DmOpenDatabaseByTypeCreator(PrefDBType,HackCreatorID,dmModeReadWrite);
    if (dbref == 0) { return 0; }
    initDatabase(dbref);
  }
  return dbref;
}

void getSoundPref(DmOpenRef dbref,UInt beepID,HackedSystemSound* sound) {
  VoidHand rechand;
  SystemSoundHackPrefRecord* rec;
  rechand = DmGetRecord(dbref,SystemSoundHackPrefRecordIndex);
  rec = (SystemSoundHackPrefRecord*)MemHandleLock(rechand);
  *sound = rec->sound[BeepIDToIndex(beepID)];
  MemHandleUnlock(rechand);
  DmReleaseRecord(dbref,SystemSoundHackPrefRecordIndex,false);
}

void setSoundPref(DmOpenRef dbref,UInt beepID,HackedSystemSound* sound) {
  VoidHand rechand;
  SystemSoundHackPrefRecord* rec;
  rechand = DmGetRecord(dbref,SystemSoundHackPrefRecordIndex);
  rec = (SystemSoundHackPrefRecord*)MemHandleLock(rechand);
  DmWrite((VoidPtr)rec,(VoidPtr)&(rec->sound[BeepIDToIndex(beepID)]) - (VoidPtr)rec,
	  sound,sizeof(HackedSystemSound));
  // which means that rec->sound[BeepIDToIndex(beepID)] = *sound;
  MemHandleUnlock(rechand);
  DmReleaseRecord(dbref,SystemSoundHackPrefRecordIndex,true);
}

void initDatabase(DmOpenRef dbref) {
  UInt at;
  ULong size;
  VoidHand rechand;
  VoidPtr recptr;
  SystemSoundHackPrefRecord* rec;
  UInt i;

  size = sizeof(SystemSoundHackPrefRecord);
  rec = (SystemSoundHackPrefRecord*)MemPtrNew(size);
  for (i = 0; i < NumOfSystemSound; i++) {
    rec->sound[i].kind = systemSoundDefault;
    rec->sound[i].melody.creator = 0;
    rec->sound[i].melody.resourceID = 0;
  }
  at = SystemSoundHackPrefRecordIndex;
  rechand = DmNewRecord(dbref,&at,size);
  recptr = MemHandleLock(rechand);
  DmWrite(recptr,0,rec,size);
  MemHandleUnlock(rechand);
  DmReleaseRecord(dbref,at,true);
  MemPtrFree(rec);
}
