/*
   SndPlaySystemSoundHack
   $Revision: 0.1 $
   Tatsuya Aoyagi (aoyagi@cs.uec.ac.jp)
   $Id: syssnd.h,v 0.1 1997/08/06 11:35:44 aoyagi Exp aoyagi $
*/
#ifndef SYSSND_H
#define SYSSND_H
#include <Pilot.h>

#define HackCreatorID 'SsHk'
#define PrefCreatorID 'SsPr'

#define MelodyDBType 'Mldy'
#define MelodyResourceType 'Mldy'

typedef struct {
  Long frequency;
  UInt duration;
  UInt amplitude;
} NoteRecord;

typedef struct {
  char title[32];
  UInt numOfNotes;
  NoteRecord notes[1];
} Melody;

#define PrefDBType 'Pref'
#define PrefDBName "System Sound Hack Pref"

typedef enum {
  systemSoundDefault = 1,
  systemSoundNone,
  systemSoundMelody
} SystemSoundKind;

typedef struct {
  ULong creator;
  Int resourceID;
} MelodyID;

typedef struct {
  SystemSoundKind kind;
  MelodyID melody;
} HackedSystemSound;

#define NumOfSystemSound (sndClick - sndInfo + 1)
#define BeepIDToIndex(beepID) ((beepID) - sndInfo)

typedef struct {
  HackedSystemSound sound[NumOfSystemSound];
} SystemSoundHackPrefRecord;

#define SystemSoundHackPrefRecordIndex 0

#endif
